!function ($) {
    $.fn.combo = function (options) {
        if (0 == this.length) return this;
        var c, d = arguments;
        this.each(function () {
            var data = $(this).data("_combo");
            if (!data) {
                data = new $.Combo($(this), options);
                $(this).data("_combo", data);
            }
        });
        return this;
    };

    $.Combo = function (obj, options) {
        this.obj = obj;
        this.opts = $.extend(true, {}, $.Combo.defaults, options);
        this.dataOpt = this.opts.data;
        this._selectedIndex = -1;
        this.addQuery = true;
        this._disabled = "undefined" != typeof this.opts.disabled ? this.opts.disabled : this.obj.attr("disabled");
        $.extend(this, this.opts.callback);
        console.log(this);
        this._init();
    };

    $.Combo.prototype = {
        constructor: $.Combo,

        _init: function () {
            var a = this.opts;
            if ("select" == this.obj[0].tagName.toLowerCase()) {
                // airtear wait
                this.originSelect = this.obj;
                this.dataOpt = this._getDataFromSelect();
            }
            this._createCombo();
            // airtear wait
            this.loadData(this.dataOpt, a.defaultSelected, a.defaultFlag);
            this._handleDisabled(this._disabled);
            this._bindEvent();
        },

        _bindEvent: function () {
            var b = this
                , c = this.opts
                , d = "." + c.listItemCls;

            b.list.on("click", d, function () {
                $(this).hasClass(c.selectedCls) || b.selectByItem($(this)),
                    b.collapse(),
                    b.input.focus(),
                "function" == typeof c.callback.onListClick && c.callback.onListClick.call(b)
            }).on("mouseover", d, function () {
                $(this).addClass(c.hoverCls).siblings().removeClass(c.hoverCls)
            }).on("mouseleave", d, function () {
                $(this).removeClass(c.hoverCls)
            });

            b.input.on("focus", function () {
                b.wrap.addClass(c.activeCls),
                    b.focus = true,
                    b.active = true,
                "function" == typeof b.onFocus && b.onFocus()
            }).on("blur", function () {
                b.focus = false
            });

            c.editable ? b.input.on("click", function () {
            }) : b.input.on("click", function () {
                b._onTriggerClick()
            });

            b.trigger && b.trigger.on("click", function () {
                b._onTriggerClick()
            });

            $(document).on("click", function (c) {
                var d = c.target || c.srcElement;
                0 == $(d).closest(b.wrap).length && 0 == $(d).closest(b.listWrap).length && b.blur()
            });

            this.listWrap.on("click", function (a) {
                a.stopPropagation()
            });
            $(window).on("resize", function () {
                b._setListPosition()
            });
            this._bindKeyEvent();
        },

        selectByText: function (a, b) {
            if (this.formattedData) {
                for (var c = this.formattedData, d = -1, e = 0, f = c.length; f > e; e++)
                    if (c[e].text === a) {
                        d = e;
                        break
                    }
                this._setSelected(d, b)
            }
        }
        ,
        selectByValue: function (a, b) {
            if (this.formattedData) {
                for (var c = this.formattedData, d = -1, e = 0, f = c.length; f > e; e++)
                    if (c[e].value === a) {
                        d = e;
                        break
                    }
                this._setSelected(d, b)
            }
        }
        ,
        selectByKey: function (a, b, c) {
            if (this.rawData) {
                var d = this
                    , e = d.opts
                    , f = this.rawData
                    , g = -1;
                if (e.addOptions || e.emptyOptions) {
                    f = this.formattedData;
                    for (var h = 0, i = f.length; i > h; h++)
                        if (f[h].value === b) {
                            g = h;
                            break
                        }
                } else
                    for (var h = 0, i = f.length; i > h; h++)
                        if (f[h][a] === b) {
                            g = h;
                            break
                        }
                this._setSelected(g, c)
            }
        }
        ,
        selectByItem: function (a, b) {
            if (a && a.parent()[0] == this.list[0]) {
                var c = a.text();
                this.selectByText(c, b)
            }
        }
        ,

        expand: function () {
            var b = this.opts;
            if (!this.active || this.isExpanded || 0 == this.filterData.length && !b.noDataText && !b.extraListHtmlCls)
                return void this.listWrap.hide();
            this.isExpanded = true,
                this.listWrap.show(),
                this._setListPosition(),
            $.isFunction(this.onExpand) && this.onExpand();
            var c = this.list.find("." + b.listItemCls);
            if (0 != c.length) {
                var d = c.filter("." + b.selectedCls);
                0 == d.length && (d = c.eq(0),
                b.autoSelectFirst && d.addClass(b.hoverCls)),
                    this._scrollToItem(d)
            }
        }
        ,
        collapse: function () {
            if (this.isExpanded) {
                var b = this.opts;
                this.listWrap.hide(),
                    this.isExpanded = false,
                this.listItems && this.listItems.removeClass(b.hoverCls),
                $.isFunction(this.onCollapse) && this.onCollapse()
            }
        }
        ,

        _setListPosition: function () {
            if (this.isExpanded) {
                var b, c, d = (this.opts,
                    $(window)), e = this.wrap.offset().top, f = this.wrap.offset().left, g = d.height(), h = d.width(), i = d.scrollTop(), j = d.scrollLeft(), k = this.wrap.outerHeight(), l = this.wrap.outerWidth(), m = this.listWrap.outerHeight(), n = this.listWrap.outerWidth(), o = parseInt(this.listWrap.css("border-top-width"));
                b = e - i + k + m > g && e > m ? e - m + o : e + k - o,
                    c = f - j + n > h ? f + l - n : f,
                    this.listWrap.css({
                        top: b,
                        left: c
                    })
            }
        }
        ,
        _scrollToItem: function (a) {
            if (a && 0 != a.length) {
                var b = this.list.scrollTop()
                    , c = b + a.position().top
                    , d = b + this.list.height()
                    , e = c + a.outerHeight();
                (b > c || e > d) && this.list.scrollTop(c)
            }
        }
        ,
        _bindKeyEvent: function () {
            var b = this
                , c = this.opts
                , d = {
                backSpace: 8,
                esc: 27,
                f7: 118,
                up: 38,
                down: 40,
                tab: 9,
                enter: 13,
                home: 36,
                end: 35,
                pageUp: 33,
                pageDown: 34,
                space: 32
            };
            this.input.on("keydown", function (e) {
                switch (e.keyCode) {
                    case d.tab:
                        b._blur();
                        break;
                    case d.down:
                    case d.up:
                        if (b.isExpanded) {
                            var f = e.keyCode == d.down ? "next" : "prev";
                            b._setItemFocus(f)
                        } else
                            b._onTriggerClick();
                        e.preventDefault();
                        break;
                    case d.enter:
                        if (b.queryDelay && window.clearTimeout(b.queryDelay),
                                b.isExpanded) {
                            var g = b.list.find("." + c.hoverCls);
                            g.length > 0 && b.selectByItem(g),
                                b.collapse()
                        } else {
                            var h = $.trim(b.input.val());
                            b.selectByText(h)
                        }
                        "function" == typeof c.callback.onEnter && c.callback.onEnter(e);
                        break;
                    case d.home:
                    case d.end:
                        if (b.isExpanded) {
                            var g = e.keyCode == d.home ? b.list.find("." + c.listItemCls).eq(0) : b.list.find("." + c.listItemCls).filter(":last");
                            b._scrollToItem(g),
                                e.preventDefault()
                        }
                        break;
                    case d.pageUp:
                    case d.pageDown:
                        if (b.isExpanded) {
                            var f = e.keyCode == d.pageUp ? "up" : "down";
                            b._scrollPage(f),
                                e.preventDefault()
                        }
                }
            }).on("keyup", function (a) {
                if (c.editable) {
                    var e = a.which
                        , f = 8 == e || 9 == e || 13 == e || 27 == e || e >= 16 && 20 >= e || e >= 33 && 40 >= e || e >= 44 && 46 >= e || e >= 112 && 123 >= e || 144 == e || 145 == e
                        , g = b.input.val();
                    f && e != d.backSpace || b.doDelayQuery(g)
                }
            }),
                $(document).on("keydown", function (a) {
                    a.keyCode == d.esc && b.collapse()
                })
        },

        doDelayQuery: function (a) {
            var b = this
                , c = b.opts
                , d = parseInt(c.queryDelay);
            isNaN(d) && (d = 0);
            if (b.queryDelay)
                window.clearTimeout(b.queryDelay);

            b.queryDelay = window.setTimeout(function () {
                b.doQuery(a)
            }, d)
        },

        getDisabled: function () {
            return this._disabled
        }
        ,
        getValue: function () {
            return this._selectedIndex > -1 ? this.formattedData[this._selectedIndex].value : this.opts.forceSelection ? "" : this.input.val()
        }
        ,
        getText: function () {
            return this._selectedIndex > -1 ? this.formattedData[this._selectedIndex].text : this.opts.forceSelection ? "" : this.input.val()
        }
        ,
        getSelectedIndex: function () {
            return this._selectedIndex
        }
        ,
        getSelectedRow: function () {
            return this._selectedIndex > -1 ? this.rawData[this._selectedIndex] : undefined
        }
        ,
        getDataRow: function () {
            return this._selectedIndex > -1 ? this.rawData[this._selectedIndex] : undefined
        }
        ,
        getAllData: function () {
            return this.formattedData
        }
        ,
        getAllRawData: function () {
            return this.rawData
        }
        ,

        _filter: function (b) {
            function c() {
                this._formatData();
                this.filterData = this.formattedData;
                this.lastQuery = b;
                this.list.empty();
                console.log(this.filterData);
                this._populateList(this.filterData);
                this.expand();
            }

            b = "undefined" == typeof b ? "" : b,
            this.input.val() != this.getText() && this.selectByText(this.input.val());
            {
                var d = this.opts
                    , e = this;
                d.maxFilter
            }
            if (this.opts.cache || ("local" == this.mode && $.isFunction(this.dataOpt) && (this.rawData = this.dataOpt()),
                    this._formatData()),
                    $.isArray(this.formattedData)) {
                if ("" == b)
                    this.filterData = this.formattedData;
                else {
                    this.filterData = [];
                    var f = [];
                    $.each(e.formattedData, function (c, g) {
                        var h = g.text;
                        if ($.isFunction(d.customMatch)) {
                            if (!d.customMatch(g, b))
                                return
                        } else {
                            var i = d.caseSensitive ? "" : "i"
                                , j = new RegExp(b.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&"), i);
                            if (-1 == h.search(j))
                                return
                        }
                        return e.filterData.push(g),
                            f.push({
                                i: c,
                                val: g.value
                            }),
                            e.filterData.length == d.maxFilter ? false : undefined
                    })
                }
                for (var g = {}, h = [], i = 0; i < this.filterData.length; i++) {
                    var k = this.filterData[i];
                    console.log(k);
                    if (!g[k.value]) {
                        g[k.value] = true;
                        h.push(k);
                    };
                }
                this.filterData = h;
                console.log(this.filterData);
                    h = [],
                    g = {},
                    100 === e.formattedLen && e.filterData.length < d.maxFilter ? e.addQuery === true && this.incrementalSearch(f, c) : (this.lastQuery = b,
                        this.list.empty(),
                        this._populateList(this.filterData),
                        this.expand())
            }
        },

        doQuery: function (a) {
            if ("local" == this.mode || "remote" == this.mode && this.opts.loadOnce)
                this._filter(a);
            else
                this._loadAjaxData("", false, a);
        },

        _handleDisabled: function (a) {
            var b = this.opts;
            this._disabled = a,
                1 == a ? this.wrap.addClass(b.disabledCls) : this.wrap.removeClass(b.disabledCls),
                this.input.attr("disabled", a)
        },

        _setSelected: function (a, b) {
            var c = this.opts, a = parseInt(a), b = "undefined" != typeof b ? !!b : true;
            if (!isNaN(a)) {
                if (!this.formattedData || 0 == this.formattedData.length) {
                    this._selectedIndex = -1;
                    return undefined;
                }
                var d = this.formattedData.length;
                if ((-1 > a || a >= d) && (a = -1),
                    this._selectedIndex != a) {
                    {
                        var e = -1 == a ? null : this.formattedData[a]
                            , f = -1 == a ? null : e.rawData
                            , g = -1 == a ? "" : e.text;
                        this.list.find("." + c.listItemCls)
                    }
                    (!b || "function" != typeof this.beforeChange || this.beforeChange(f)) && (c.editable && -1 == a && this.focus || this.input.val(g),
                        this._selectedIndex = a,
                    b && "function" == typeof this.onChange && this.onChange(f),
                    this.originSelect && (this.originSelect[0].selectedIndex = a))
                }
            }
        },

        empty: function () {
            this._setSelected(-1, false);
            this.input.val("");
            this.list.empty();
            this.rawData = null;
            this.formattedData = null;
        },

        _getRenderMode: function () {
            var b, c = this.dataOpt;
            if ($.isFunction(c))  c = c();

            if ($.isArray(c)) {
                this.rawData = c;
                b = "local";
            }
            else {
                if ("string" == typeof c) {
                    this.url = c;
                    b = "remote";
                }
            }
            return b;
        },

        _formatData: function () {
            if ($.isArray(this.rawData)) {
                var b = this
                    , c = b.opts;
                b.formattedData = [];
                if (c.emptyOptions)
                    b.formattedData.push({
                        text: "(空)",
                        value: 0
                    });
                if (c.addOptions)
                    b.formattedData.push(c.addOptions);

                $.each(this.rawData, function (d, e) {
                    var f = {};
                    f.text = $.isFunction(c.formatText) ? c.formatText(e) : e[c.text];
                    f.value = $.isFunction(c.formatValue) ? c.formatValue(e) : e[c.value];
                    f.rawData = e;
                    b.formattedData.push(f);
                });

                b.formattedLen = b.formattedData.length;
            }
        },

        _populateList: function (b) {
            if (b) {
                var c = this
                    , d = c.opts;
                if (0 == b.length)
                    d.forceSelection && ($("<div />").addClass(d.tipsCls).html(d.noDataText).appendTo(c.list),
                        this._setListLayout());
                else {
                    for (var e = 0, f = b.length; f > e; e++) {
                        var g = b[e]
                            , h = g.text
                            , i = g.value
                            , j = $("<div />").attr({
                            "class": d.listItemCls + (e == this._selectedIndex ? " " + d.selectedCls : ""),
                            "data-value": i
                        });
                        d.disStrict ? j.html(h).appendTo(c.list) : j.text(h).appendTo(c.list)
                    }
                    this._setListLayout()
                }
            }
        },

        _setListLayout: function () {
            var a, b, c = this.opts, d = parseInt(c.listHeight), e = 0, f = this.trigger ? this.trigger.outerWidth() : 0, g = parseInt(c.minListWidth), h = parseInt(c.maxListWidth);
            this.listWrap.width("auto");
            this.list.height("auto");
            this.listWrap.show();
            this.isExpanded = true;
            b = this.list.height();
            if (!isNaN(d) && d >= 0) {
                d = Math.min(d, b);
                this.list.height(d);
            }
            if ("auto" == c.listWidth || "auto" == c.width) {
                a = this.listWrap.outerWidth();
                if (b < this.list.height()) {
                    e = 20;
                    a += e;
                }
            }
            else {
                a = parseInt(c.listWidth);
                if (isNaN(a))
                    a = this.wrap.outerWidth();
            }
            if ("auto" == c.width) {
                var i = this.listWrap.outerWidth() + Math.max(f, e);
                this._setComboLayout(i)
            }
            g = isNaN(g) ? this.wrap.outerWidth() : Math.max(g, this.wrap.outerWidth());

            !isNaN(g) && g > a && (a = g),
            !isNaN(h) && a > h && (a = h),
                a -= this.listWrap.outerWidth() - this.listWrap.width(),
                this.listWrap.width(a),
                this.listWrap.hide(),
                this.isExpanded = false
        },

        loadData: function (dataOpt, defaultSelected, defaultFlag) {
            this.xhr && this.xhr.abort();
            this.empty(false);
            this.dataOpt = dataOpt;
            this.mode = this._getRenderMode();
            if (this.mode) {
                if ("local" == this.mode) {
                    this._formatData();
                    this._populateList(this.formattedData);
                    this._setDefaultSelected(defaultSelected, defaultFlag);
                }
                else if ("remote" == this.mode)
                    this._loadAjaxData(defaultSelected, defaultFlag);
            }
        },

        _setDefaultSelected: function (b, c) {
            var d = this.opts;
            if ("function" == typeof b && (defaultSelected = defaultSelected.call(this, this.rawData)),
                    isNaN(parseInt(b)))
                if ($.isArray(b))
                    this.selectByKey(b[0], b[1], c);
                else if (this.originSelect) {
                    var e = this.originSelect[0].selectedIndex;
                    this._setSelected(e, c)
                } else
                    d.autoSelect && this._setSelected(0, c);
            else {
                var e = parseInt(b);
                this._setSelected(e, c)
            }
        },

        _createCombo: function () {
            var b, c, d, options = this.opts, width = parseInt(this.opts.width);

            if (this.originSelect) this.originSelect.hide();

            if ("input" == this.obj[0].tagName.toLowerCase())
                this.input = this.obj;
            else {
                c = this.obj.find("." + options.inputCls);
                this.input = c.length > 0 ? c : $('<input type="text" class="' + options.inputCls + '"/>');
            }

            this.input.attr({
                autocomplete: "off",
                readOnly: !options.editable
            }).css({
                cursor: options.editable ? "" : "default"
            });

            d = $(this.obj).find("." + options.triggerCls);
            if (d.length > 0)
                this.trigger = d;
            else if (options.trigger)
                this.trigger = $('<span class="' + options.triggerCls + '"></span>');

            b = this.obj.hasClass(options.wrapCls) ? this.obj : this.obj.find("." + options.wrapCls);
            if (b.length > 0)
                this.wrap = b.append(this.input, this.trigger);
            else if (this.trigger) {
                this.wrap = $('<span class="' + options.wrapCls + '"></span>').append(this.input, this.trigger);
                if (this.originSelect && this.obj[0] == this.originSelect[0] || this.obj[0] == this.input[0]) {
                    if (this.obj.next().length > 0)
                        this.wrap.insertBefore(this.obj.next());
                    else
                        this.wrap.appendTo(this.obj.parent());
                }
                else
                    this.wrap.appendTo(this.obj);
            }

            if (this.wrap && options.id)
                this.wrap.attr("id", options.id);

            if (!this.wrap)
                this.wrap = this.input;

            this._setComboLayout(width);

            this.list = $("<div />").addClass(options.listCls).css({
                position: "relative",
                overflow: "auto"
            });
            this.listWrap = $("<div />").addClass(options.listWrapCls).attr("id", options.listId).hide().append(this.list).css({
                position: "absolute",
                top: 0,
                zIndex: options.zIndex
            });
            if (options.extraListHtml)
                $("<div />").addClass(options.extraListHtmlCls).append(options.extraListHtml).appendTo(this.listWrap);

            if (options.listRenderToBody) {
                if (!$.Combo.allListWrap)
                    ($.Combo.allListWrap = $('<div id="COMBO_WRAP"/>').appendTo("body"));
                this.listWrap.appendTo($.Combo.allListWrap);
            }
            else
                this.wrap.after(this.listWrap);
        },

        _setComboLayout: function (width) {
            if (width) {
                var options = this.opts
                    , maxWidth = parseInt(options.maxWidth)
                    , minWidth = parseInt(options.minWidth);
                if (!isNaN(maxWidth) && width > maxWidth) width = maxWidth;
                if (!isNaN(minWidth) && minWidth > width) width = minWidth;
                width -= this.wrap.outerWidth() - this.wrap.width();
                this.wrap.width(width);
                if (this.wrap[0] != this.input[0]) {
                    var e = width - (this.trigger ? this.trigger.outerWidth() : 0) - (this.input.outerWidth() - this.input.width());
                    this.input.width(e)
                }
            }
        },

    };

    $.Combo.defaults = {
        data: null,
        text: "text",
        value: "value",
        formatText: null,
        formatValue: null,
        defaultSelected: undefined,
        defaultFlag: true,
        autoSelect: true,
        disabled: undefined,
        editable: false,
        caseSensitive: false,
        forceSelection: true,
        cache: true,
        queryDelay: 100,
        maxFilter: 20,
        minChars: 0,
        customMatch: null,
        addQuery: "",
        noDataText: "没有匹配的选项",
        autoSelectFirst: true,
        width: undefined,
        minWidth: undefined,
        maxWidth: undefined,
        listWidth: undefined,
        listHeight: 150,
        maxListWidth: undefined,
        maxListWidth: undefined,
        zIndex: 1e3,
        listRenderToBody: true,
        extraListHtml: undefined,
        disStrict: false,
        ajaxOptions: {
            type: "post",
            dataType: "json",
            queryParam: "query",
            timeout: 1e4,
            formatData: null,
            loadingText: "Loading...",
            success: null,
            error: null,
            errorText: "数据加载失败"
        },
        loadOnce: true,
        id: undefined,
        listId: undefined,
        wrapCls: "ui-combo-wrap",
        focusCls: "ui-combo-focus",
        disabledCls: "ui-combo-disabled",
        activeCls: "ui-combo-active",
        inputCls: "input-txt",
        triggerCls: "trigger",
        listWrapCls: "ui-droplist-wrap",
        listCls: "droplist",
        listItemCls: "list-item",
        selectedCls: "selected",
        hoverCls: "on",
        loadingCls: "loading",
        tipsCls: "tips",
        extraListHtmlCls: "extra-list-ctn",
        callback: {
            onFocus: null,
            onBlur: null,
            beforeChange: null,
            onChange: null,
            onExpand: null,
            onCollapse: null,
            onEnter: null,
            onListClick: null
        }
    };


}(jQuery);